#!/usr/bin/env python
"""

reverseRepr
by Joel R. Voss

Reverse Repr is needed where you need to parse a file where you have written the output of repr().
I'm surprised that the docs actually recommend eval(). This is why we don't eval:
eval("\"test\" + "import os" + "os.system(just_imagine)" + \"\n")

"""

def reverseRepr(data, outputType = 'string'):
	"""
	data, outputType
	outputType:
		returns string or array depending on value
		string: (default) returns a string
		array: returns an array
		other: returns an array with a single string
	"""
	outputArray = (outputType == 'array')
	outputString = (outputType == 'string')
	
	output_array = []
	output = ''
	i = 0
	endChar = data[0]
	while i < len(data):
		if data[i] == '\\':
			# parse \
			if i+1 >= len(data):
				print 'error parsing data at end', data[i:]
				return output
			#end if
			if data[i+1] == 'x':
				if i+3 >= len(data):
					print 'error parsing data at end', data[i:]
					return output
				#end if
				# Next 2 are hex
				hexChar = data[i+2:i+4]
				output += chr(int(hexChar, 16))
				i += 3
			elif data[i+1] == 't':
				# tab \t
				output += '\t'
				i += 1
			elif data[i+1] == 'r':
				# char return \r
				output += '\r'
				i += 1
			elif data[i+1] == 'n':
				# newline \n
				output += '\n'
				i += 1
			elif data[i+1] == '"':
				# quote \"
				output += '"'
				i += 1
			elif data[i+1] == "'":
				# apostrophe \'
				output += "'"
				i += 1
			elif data[i+1] == '\\':
				# backslash \\
				output += '\\'
				i += 1
			else:
				print "I don't know how to parse", repr(data[i+1])
			#end if
		elif data[i] == endChar:
			if i == 0 or i == len(data) - 1:
				# These go away.
				pass
			elif outputArray:
				# It's an array
				output_array.append(output)
				output = ''
			else:
				# It's an array, but we don't output. Hmm
				pass
			#end if
		else:
			output += data[i]
		#end if
		i += 1
	#loop
	if outputString:
		return output
	else:
		output_array.append(output)
		return output_array
	#end if
#end def reverseRepr(data, outputType = 'string')

def main():
	a = ''.join([chr(a) for a in range(256)])
	# Success
	print a == reverseRepr(repr(a))
	print repr(a) == repr(reverseRepr(repr(a)))
	# Here is repr
	print repr(a)
	# Here is repr(b) where b is reversed from repr(a).
	print repr(reverseRepr(repr(a)))
#end def main()


if __name__ == '__main__':
	main()
#end if
